import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikCircularClickButtonProps.dart';
import 'UikWidget.dart';

class UikCircularClickButton extends UikWidget {
  WidgetType _widgetType;
  UikCircularClickButtonProps _uikCircularClickButtonProps;
  UikCircularClickButton(this._widgetType, this._uikCircularClickButtonProps)
      : super(_widgetType, _uikCircularClickButtonProps);

  @override
  _UikCircularClickButtonState createState() =>
      _UikCircularClickButtonState(_uikCircularClickButtonProps);
}

class _UikCircularClickButtonState extends State<UikCircularClickButton> {
  bool isChecked = false;
  UikCircularClickButtonProps _uikCircularClickButtonProps;
  _UikCircularClickButtonState(this._uikCircularClickButtonProps);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        setState(() {
          isChecked = !isChecked;
        });
      },
      child: Container(
        margin: EdgeInsets.only(
            left: _uikCircularClickButtonProps.leftMargin,
            right: _uikCircularClickButtonProps.rightMargin),
        width: _uikCircularClickButtonProps.width,
        height: _uikCircularClickButtonProps.height,
        decoration: BoxDecoration(
          shape: BoxShape.circle,
          color: isChecked
              ? _uikCircularClickButtonProps.activeColor
              : _uikCircularClickButtonProps.inactiveColor,
        ),
        child: isChecked
            ? Icon(
                Icons.check,
                color: Colors.black,
                size: 15,
              )
            : null,
      ),
    );
  }
}
