import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikContainerProps.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';

class UikContainer extends UikWidget {
  WidgetType _widgetType;
  UikContainerProps _UikContainerProps;
  UikContainer(this._widgetType, this._UikContainerProps)
      : super(_widgetType, _UikContainerProps);

  @override
  _UikContainerState createState() => _UikContainerState(_UikContainerProps);
}

class _UikContainerState extends State<UikContainer> {
  UikContainerProps _uikContainerProps;
  _UikContainerState(this._uikContainerProps);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () async {
        await executeUikWidgetAction(_uikContainerProps.action, context);
      },
      child: Container(
        width: _uikContainerProps.width ?? double.maxFinite,
        height: _uikContainerProps.height,
        decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          color: _uikContainerProps.bgColor,
          borderRadius: BorderRadius.circular(_uikContainerProps.borderRadius),
        ),
        margin: EdgeInsets.fromLTRB(
          _uikContainerProps.leftMargin,
          _uikContainerProps.topMargin,
          _uikContainerProps.rightMargin,
          _uikContainerProps.bottomMargin,
        ),
        child: _uikContainerProps.widget,
      ),
    );
  }
}
