import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';
import '../props/UikDropDownProps.dart';
import 'UikWidget.dart';

class UikDropDown extends UikWidget {
  WidgetType _widgetType;
  UikDropDownProps _uikDropDownProps;
  UikDropDown(this._widgetType, this._uikDropDownProps)
      : super(_widgetType, _uikDropDownProps);

  @override
  _UikDropDownState createState() => _UikDropDownState(_uikDropDownProps);
}

class _UikDropDownState extends State<UikDropDown> {
  UikDropDownProps _uikDropDownProps;
  _UikDropDownState(this._uikDropDownProps);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Container(
          width: 50.0, // Adjust the width as needed
          height: 50.0, // Adjust the height as needed
          child: IconButton(
            icon: Icon(_uikDropDownProps.mainIcon),
            onPressed: () {
              _showPopupMenu(context);
            },
          ),
        ),
      ),
    );
  }

  void _showPopupMenu(BuildContext context) {
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          content: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              _buildDialogButton(
                icon: _uikDropDownProps.subIcon1,
                onPressed: () {
                  _handleEditButtonClick(context);
                },
              ),
              SizedBox(height: 10.0),
              _buildDialogButton(
                icon: _uikDropDownProps.subIcon2,
                onPressed: () {
                  _handleDeleteButtonClick(context);
                },
              ),
            ],
          ),
        );
      },
    );
  }

  Widget _buildDialogButton(
      {required IconData icon, required Function() onPressed}) {
    return InkWell(
      onTap: onPressed,
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Row(
          children: [
            Icon(
              icon,
              size: 20.0, // Adjust the size as needed
            ),
            SizedBox(width: 10.0),
            Text(
              onPressed == _handleEditButtonClick
                  ? "Edit"
                  : onPressed == _handleDeleteButtonClick
                      ? "Delete"
                      : "",
              style: TextStyle(fontSize: 16.0),
            ),
          ],
        ),
      ),
    );
  }

  void _handleEditButtonClick(BuildContext context) {
    Navigator.of(context).pop(); // Close the dialog
    // Add your edit logic here
  }

  void _handleDeleteButtonClick(BuildContext context) {
    Navigator.of(context).pop(); // Close the dialog
    // Add your delete logic here
  }
}
