import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikExpandedTextProps.dart';

class UikExpandedText extends UikWidget {
  WidgetType _widgetType;
  UikExpandedTextProps _UikExpandedTextProps;
  UikExpandedText(this._widgetType, this._UikExpandedTextProps)
      : super(_widgetType, _UikExpandedTextProps);
  @override
  _UikExpandedTextState createState() =>
      _UikExpandedTextState(_UikExpandedTextProps);
}

class _UikExpandedTextState extends State<UikExpandedText> {
  UikExpandedTextProps _uikExpandedTextProps;
  _UikExpandedTextState(this._uikExpandedTextProps);
  bool isExpanded = false;

  @override
  Widget build(BuildContext context) {
    return Container(
      // color: Color.fromARGB(115, 213, 203, 203),
      //height: _uikExpandedTextProps.height,
      padding: EdgeInsets.fromLTRB(
        1,
        _uikExpandedTextProps.topMargin,
        _uikExpandedTextProps.rightMargin,
        _uikExpandedTextProps.bottomMargin,
      ),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            _uikExpandedTextProps.text,
            overflow: isExpanded ? TextOverflow.visible : TextOverflow.ellipsis,
            maxLines: isExpanded ? null : 3,
            style: TextStyle(
              fontSize: _uikExpandedTextProps.size,
              color: Colors.black,
            ),
          ),
          // Text(
          //   isExpanded
          //       ? _uikExpandedTextProps.text
          //       : '${_uikExpandedTextProps.text.substring(0, 100)}... ',
          //   style: TextStyle(fontSize: 16, color: Colors.yellow),
          // ),
          Align(
            alignment: Alignment.centerRight,
            child: GestureDetector(
              onTap: () {
                setState(() {
                  isExpanded = !isExpanded;
                });
              },
              child: Opacity(
                opacity: isExpanded ? 0.5 : 1.0,
                child: Text(
                  isExpanded ? 'Read less' : 'Read more',
                  style: TextStyle(
                    fontSize: 15,
                    color: Colors.blue,
                    fontWeight: FontWeight.bold,
                  ),
                ),
              ),
            ),
          ),
        ],
      ),
      // child: LayoutBuilder(
      //   builder: (context, constraints) {
      //     final textPainter = TextPainter(
      //       text: TextSpan(
      //           text: _uikExpandedTextProps.text,
      //           style: TextStyle(fontSize: 16)),
      //       maxLines: isExpanded ? null : _uikExpandedTextProps.maxlines,
      //       textDirection: TextDirection.ltr,
      //     )..layout(maxWidth: constraints.maxWidth);
      //     // final textLines = textPainter.text!.toString().split('\n');
      //     final textLines = _uikExpandedTextProps.text.split('\n');
      //     return Column(
      //       crossAxisAlignment: CrossAxisAlignment.start,
      //       children: [
      //         if (isExpanded)
      //           Text(
      //             _uikExpandedTextProps.text,
      //             style: TextStyle(fontSize: 16),
      //           )
      //         else
      //           for (int i = 0; i < (_uikExpandedTextProps.maxlines ?? 0); i++)
      //             Opacity(
      //               opacity:
      //                   i == _uikExpandedTextProps.maxlines! - 1 ? 1.0 : 0.5,
      //               child: Text(
      //                 textLines[i],
      //                 style: TextStyle(fontSize: 16),
      //               ),
      //             ),
      //         InkWell(
      //           onTap: () {
      //             setState(() {
      //               isExpanded = !isExpanded;
      //             });
      //           },
      //           child: Text(
      //             isExpanded ? ' Read Less' : ' Read More',
      //             style: TextStyle(
      //               color: Colors.blue,
      //               fontWeight: FontWeight.bold,
      //             ),
      //           ),
      //         ),
      //       ],
      //     );
      //   },
      // ),
    );
  }
}

// class FadeOverflowText extends StatelessWidget {
//   final String text;
//   final int maxLines;

//   const FadeOverflowText({
//     required this.text,
//     required this.maxLines,
//   });

//   @override
//   Widget build(BuildContext context) {
//     return LayoutBuilder(
//       builder: (context, constraints) {
//         final textPainter = TextPainter(
//           text: TextSpan(text: text, style: TextStyle(fontSize: 16)),
//           maxLines: maxLines,
//           textDirection: TextDirection.ltr,
//         )..layout(maxWidth: constraints.maxWidth);

//         if (textPainter.didExceedMaxLines) {
//           return Column(
//             crossAxisAlignment: CrossAxisAlignment.start,
//             children: [
//               for (int i = 0; i < maxLines; i++)
//                 FadeTransition(
//                   opacity: Tween<double>(
//                     begin: i == maxLines - 1 ? 1.0 : 0.5,
//                     end: 1.0,
//                   ).animate(CurvedAnimation(
//                     parent: AlwaysStoppedAnimation(1),
//                     curve: Interval(i / (maxLines - 1), 1.0),
//                   )),
//                   child: Text(
//                     textPainter.text!.text!.split('\n')[i],
//                     overflow: TextOverflow.fade,
//                     style: TextStyle(fontSize: 16),
//                   ),
//                 ),
//             ],
//           );
//         } else {
//           return Text(
//             text,
//             style: TextStyle(fontSize: 16),
//           );
//         }
//       },
//     );
//   }
// }



