import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikJobBoxProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:ui_sdk/utils/extensions.dart';

UikJobBoxProps $UikJobBoxPropsFromJson(Map<String, dynamic> json) {
  final UikJobBoxProps uikJobBoxProps = UikJobBoxProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikJobBoxProps.id = id;
  }
  final double? elevation = jsonConvert.convert<double>(json['elevation']);
  if (elevation != null) {
    uikJobBoxProps.elevation = elevation;
  }
  final String? image = jsonConvert.convert<String>(json['image']);
  if (image != null) {
    uikJobBoxProps.image = image;
  }
  final String? cityName = jsonConvert.convert<String>(json['cityName']);
  if (cityName != null) {
    uikJobBoxProps.cityName = cityName;
  }
  final String? jobType = jsonConvert.convert<String>(json['jobType']);
  if (jobType != null) {
    uikJobBoxProps.jobType = jobType;
  }
  final Map<String, dynamic>? jobName =
      jsonConvert.convert<Map<String, dynamic>>(json['jobName']);
  if (jobName != null) {
    uikJobBoxProps.jobName =
        UikText(WidgetType.UikText, UikTextProps.fromJson(jobName));
  }
  final Map<String, dynamic>? companyText =
      jsonConvert.convert<Map<String, dynamic>>(json['companyText']);
  if (companyText != null) {
    uikJobBoxProps.companyNamefirstText = companyText["text"][0];
    uikJobBoxProps.companyText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(companyText));
  }
  final int? vacancy = jsonConvert.convert<int>(json['vacancy']);
  if (vacancy != null) {
    uikJobBoxProps.vacancy = vacancy;
  }
  final Map<String, dynamic>? salary =
      jsonConvert.convert<Map<String, dynamic>>(json['salary']);
  if (salary != null) {
    uikJobBoxProps.salary =
        UikText(WidgetType.UikText, UikTextProps.fromJson(salary));
  }
  final bool? isUrgentHiring =
      jsonConvert.convert<bool>(json['isUrgentHiring']);
  if (isUrgentHiring != null) {
    uikJobBoxProps.isUrgentHiring = isUrgentHiring;
  }

  final String? upperBorderColor =
      jsonConvert.convert<String>(json['upperBorderColor']);
  if (upperBorderColor != null) {
    uikJobBoxProps.upperBorderColor = upperBorderColor.toColor();
  }

  List<Color> mapToListSortedByKey(Map<String, dynamic> map) {
    List<String> sortedKeys = map.keys.toList()..sort();

    List<Color> sortedList = sortedKeys
        .map((key) => map[key].toString().toColor())
        .where((color) => color != null)
        .toList();
    // if(sortedList.isEmpty){
    //   return  [Colors.yellow.shade400, Colors.yellow.shade100];
    // }

    return sortedList;
  }

  final String? gradient = jsonConvert.convert<String>(json['gradient']);
  if (gradient != null) {
    final List<dynamic> jsons = json["gradient"];
    //   List<Color> sortedList = mapToListSortedByKey(jsons);
    List<Color> list = [];
    for (var i = 0; i < jsons.length; i++) {
      list.add(jsons[i].toString().toColor());
    }
    uikJobBoxProps.gradient = list;
  }
  final List<dynamic>? tag = jsonConvert.convert<List<dynamic>>(json["tag"]);
  if (tag != null) {
    for (var i = 0; i < tag.length; i++) {
      var icons;
      var texts;
      var bgColors;
      var textColors;
      final Map<String, dynamic>? icon =
          jsonConvert.convert<Map<String, dynamic>>(tag[i]['icon']);
      if (icon != null) {
        icons = UikIcon(WidgetType.UikText, UikIconProps.fromJson(icon));
      }
      final Map<String, dynamic>? text =
          jsonConvert.convert<Map<String, dynamic>>(tag[i]['text']);
      if (text != null) {
        texts = UikText(WidgetType.UikText, UikTextProps.fromJson(text));
        // final String? id = jsonConvert.convert<String>(tag[i]['id']);
        // if (id != null) {
        //   texts = "$text $id";
        // } else {
        //   texts = text;
        // }
      }

      final String? bgColor = jsonConvert.convert<String>(tag[i]['bgColor']);
      if (bgColor != null) {
        bgColors = bgColor.toColor();
      }
      uikJobBoxProps.tag.add(TagProps(
        icon: icons,
        text: texts,
        bgColor: bgColors ?? Colors.black,
      ));
    }
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikJobBoxProps.action = action;
  }
  return uikJobBoxProps;
}
