import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikValidationButtonProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/utils/UiSdkUtils.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikTextProps.dart';

UikValidationButtonProps $UikValidationButtonPropsFromJson(
    Map<String, dynamic> json) {
  final UikValidationButtonProps uikValidationButtonProps =
      UikValidationButtonProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikValidationButtonProps.id = id;
  }
  final Map<String, dynamic> text =
      jsonConvert.convert<Map<String, dynamic>>(json['text'])!;

  if (text != null) {
    if (json['text']['id'] == "icon") {
      uikValidationButtonProps.text =
          UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['text']));
    } else if (json['text']['id'] == 'text') {
      UiSdkUtils.prettyPrintJson(json['text']);
      uikValidationButtonProps.text =
          UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
    }
  }

  final String? borderColor = jsonConvert.convert<String>(json['borderColor']);
  if (borderColor != null) {
    uikValidationButtonProps.borderColor = borderColor.toColor();
  }

  String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikValidationButtonProps.backgroundColor = backgroundColor.toColor();
  }

  final double? width = jsonConvert.convert<double>(json['width']);
  if (width != null) {
    uikValidationButtonProps.width = width;
  } else {
    uikValidationButtonProps.width = null;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikValidationButtonProps.height = height;
  } else {
    uikValidationButtonProps.height = null;
  }

  final double? verticalPadding =
      jsonConvert.convert<double>(json['verticalPadding']);
  if (verticalPadding != null) {
    uikValidationButtonProps.verticalPadding = verticalPadding;
  }

  final double? horizontalPadding =
      jsonConvert.convert<double>(json['horizontalPadding']);
  if (horizontalPadding != null) {
    uikValidationButtonProps.horizontalPadding = horizontalPadding;
  }

  final double? borderRadius =
      jsonConvert.convert<double>(json['borderRadius']);
  if (borderRadius != null) {
    uikValidationButtonProps.borderRadius = borderRadius;
  }
  final String? icon = jsonConvert.convert<String>(json['icon']);
  if (icon != null) {
    if (json['icon']['id'] == 'icon') {
      uikValidationButtonProps.icon =
          UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['icon']));
    } else if (json['icon']['id'] == 'text') {
      UiSdkUtils.prettyPrintJson(json['icon']);
      uikValidationButtonProps.icon =
          UikText(WidgetType.UikText, UikTextProps.fromJson(json['icon']));
    }
  }

  final String? image = jsonConvert.convert<String>(json['image']);
  if (image != null) {
    uikValidationButtonProps.image = UikImage(
      WidgetType.UikImage,
      UikImageProps.fromJson(
        json['image'],
      ),
    );
  }

  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikValidationButtonProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikValidationButtonProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikValidationButtonProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikValidationButtonProps.bottomMargin = bottomMargin;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikValidationButtonProps.action = action;
  }
  return uikValidationButtonProps;
}
