import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/UikContainerProps.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

class UikContainerProps extends WidgetProps {
  late String? id;
  late String? type;
  late double? width;
  late double? height;
  late Color? bgColor = Colors.transparent;
  late double borderRadius = 0;
  late double topMargin = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late Widget? widget;
  late UikAction action;
  UikContainerProps();

  factory UikContainerProps.fromJson(Map<String, dynamic> json) =>
      $UikContainerPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
