import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_DropDown_pops.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikDropDownProps extends WidgetProps {
  late String id;
  late IconData mainIcon = Icons.menu;
  late IconData subIcon1 = Icons.edit;
  late IconData subIcon2 = Icons.delete;
  double height = 64.0;
  double leftMargin = 0.0;
  double rightMargin = 0.0;
  double topMargin = 0.0;
  double bottomMargin = 0.0;
  String text = "";
  late UikAction action;

  UikDropDownProps();

  factory UikDropDownProps.fromJson(Map<String, dynamic> json) =>
      $UikDropDownPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
