import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_jobBox_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

@JsonSerializable()
class UikJobBoxProps extends WidgetProps {
  late String? id;
  late double elevation = 4.0;
  late String? image = null;
  late Widget? companyText;
  late Widget? jobName;
  late bool isUrgentHiring = false;
  late String? cityName;
  late String companyNamefirstText = "#";
  late String? jobType;
  late int? vacancy;
  late double topMargin = 8;
  late double leftMargin = 8;
  late double rightMargin = 8;
  late double bottomMargin = 8;
  late Widget? salary;
  late double borderWidth = 1.2;
  late double borderRadius = 8;
  late List<TagProps> tag = [];
  late Color upperBorderColor = Colors.yellow;
  late List<Color> gradient = [Colors.yellow.shade400, Colors.yellow.shade100];
  late UikAction action;

  UikJobBoxProps();

  factory UikJobBoxProps.fromJson(Map<String, dynamic> json) =>
      $UikJobBoxPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}

class TagProps {
  final Widget? icon;
  final Widget? text;
  final Color bgColor;

  TagProps({
    required this.text,
    this.icon,
    this.bgColor = Colors.black,
  });
}
