import 'dart:convert';

import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_job_props.g.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

@JsonSerializable()
class UikJobProps extends WidgetProps {
  late String? id;
  late double padding = 8.0;
  late double elevation = 4.0;
  late double borderRadius = 10.0;
  late String? image = null;
  late String jobNameText;
  late String companyText;
  late String descriptionText;
  late double? startRange = 0;
  late double? endRange;
  late int? vacantSeat;
  late String locationText;
  late String experienceText;
  late String jobTypeText;
  late String educationText;

  UikJobProps();

  factory UikJobProps.fromJson(Map<String, dynamic> json) =>
      $UikJobPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
