import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';

import 'package:ui_sdk/props/WidgetProps.dart';
import 'package:ui_sdk/generated/json/UikScrollCarouselProps.g.dart';

@JsonSerializable()
class UikScrollCarouselProps extends WidgetProps {
  late String id;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late double viewPort = 0.8;
  late double topMargin = 0.0;
  late bool autoScrollEnabled = true;
  late bool swipeEnabled = true;
  late bool buttonEnabled = false;
  late double height;
  late MainAxisAlignment buttonAlign = MainAxisAlignment.center;
  late List<Widget> widgets = [];
  late int autoPlayInterval = 2;
  late bool enlargeCenter = true;
  late bool pageSnapping = true;
  late double prevIconSize = 15;
  late double nextIconSize = 15;
  late double prevIconBorderRadius = 0;
  late double nextIconBorderRadius = 0;
  late bool infiniteScroll = true;
  late Color? prevIconbgColor = Colors.black45;
  late Color? nextIconbgColor = Colors.black45;
  late Color? prevIconColor = Colors.black87;
  late Color? nextIconColor = Colors.black87;
  late Axis scrollAxis = Axis.vertical;
  UikScrollCarouselProps();

  factory UikScrollCarouselProps.fromJson(Map<String, dynamic> json) =>
      $UikScrollCarouselPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
