import 'package:flutter/cupertino.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:url_launcher/url_launcher.dart';

import '../ApiResponseState.dart';

enum UikActionType { UIK_OPEN_WEB }

executeUikWidgetAction(UikAction uikAction,BuildContext? context) async {

  if (uikAction.tap.type.startsWith("UIK")) {
    UikActionType tapAction = UikActionType.values.firstWhere(
            (e) => e.toString() == "UikActionType." + uikAction.tap.type);
    switch (tapAction) {
      case UikActionType.UIK_OPEN_WEB:
        launchURL(uikAction.tap.data.url);
        break;
      default:
        break;
    }
  } else {
    if(context!=null){
      var cubit = context.read<ApiResponseCubit>();
      cubit.state.actionFunction(uikAction);
    }
  }
}

launchURL(url) async {
  if (await canLaunch(url)) {
    await launch(url);
  } else {
    throw 'Could not launch $url';
  }
}
